## Script (Python) "getPaymentsFolderInfo"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: getPaymentsFolderInfo.py 2480 2007-10-30 15:23:25Z joachim $
"""
Info for the PaymentsFolder
"""
from Products.AdvancedQuery import Eq, Between, Le,In

mtool = context.portal_membership
wftool = context.portal_workflow
member = mtool.getAuthenticatedMember()
payments_catalog = context.payments_catalog
aq_payments = payments_catalog.evalAdvancedQuery
if mtool.isAnonymousUser():
    return None
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass

import DateTime
request = context.REQUEST
#students = context.portal_url.getPortalObject().campus.students
student_id = context.getStudentId()
if student_id is None:
    return context.REQUEST.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())
#student = getattr(students,student_id)
student_record = context.students_catalog.getRecordByKey(student_id)


info = {}
is_so = info['is_so'] = context.isSectionOfficer()
is_student = info['is_student'] = context.isStudent()
info['student_name'] = student_record.name
info['query_url'] = "https://webpay.interswitchng.com/paydirect/services/TransactionQueryURL.aspx"
review_state = info['review_state'] = student_record.review_state
parttime = student_record.mode and student_record.mode.endswith('_pt')
fulltime = student_record.mode and student_record.mode.endswith('_ft')


session = student_record.session
next_info = context.getNextInfo(student_record)
info['next_session'] = next_info['next_session_id']
info['next_session_str'] = next_info['next_session_str']
info['payment_method'] = ""
info['reasons'] = next_info['reasons']

# begin customization

if review_state == 'cleared_and_validated':
    info['payment_method'] = "online_payment"
#elif review_state == 'cleared_and_validated' and session == '07':
#    info['payment_method'] = "sc_payment"
elif review_state == 'returning' and info['next_session'] != session:
    info['payment_method'] = "online_payment"
info['prod_id'] = '105'

# end customization

info['student_name'] = student_record.name
payments_path = "%s/campus/students/%s/payments" % (context.portal_url(),student_id)
payments = []
payment_records = aq_payments(Eq('student_id',student_id)) # & Eq('session_id',student_record.session))
vocabularies = context.portal_vocabularies
paid_fees = []
for payment in payment_records:
    if payment.status == "paid":
        paid_fees += "%s_%s" % (payment.category,payment.session_id),
#info['pf'] = paid_fees
for payment in payment_records:
    row = {}
    row['id'] = payment.key
    if payment.status == 'invalid':
        row['title'] = "Invalid Payment, Naira %s, %s" % (payment.amount,
                                                          payment.date.strftime("%d/%m/%y %H:%M:%S"))
    else:
        row['title'] = "%s for Session %s, Naira %s, %s" % (vocabularies.payment_categories.get(payment.category),
                                                            vocabularies.sessions.get(payment.session_id),
                                                            payment.amount,
                                                            payment.date.strftime("%d/%m/%y %H:%M:%S"))
    oid = payment.order_id
    onr = oid.rfind('-')+1
    if onr > 0:
        start_pos = onr
    else:
        start_pos = 6
    url = row['url'] = "%s/p%s" % (payments_path,oid[start_pos:])
    row['is_requeryable'] = "%s_%s" % (payment.category,payment.session_id) not in paid_fees and not payment.resp_desc and payment.type == 'online'# or str(member) in ('admin',)  # customized too
    row['is_approvable'] = is_so and row['is_requeryable'] and payment.category == 'schoolfee' # does not make sense for maintenance
    row['resp_desc'] = payment.resp_desc or 'Payment Process Interrupted'
    row['trans_ref'] = payment.order_id
    if row['is_requeryable']:
        row['callback_url'] = "%(url)s/interswitch_cb" % row
#        if payment.category == 'schoolfee':
#            row['callback_url'] = "%(url)s/interswitch_cb" % row
#        elif payment.category == 'hostel_maintenance':
#            row['callback_url'] = "%(url)s/interswitch_acco_cb" % row
#        else:
        href = '%(query_url)s' % info
        href += '?transRef=%(trans_ref)s' % row
        href += '&prodID=%(prod_id)s' % info
        href += '&redirectURL=%(callback_url)s' % row
        row['href'] = href
    if payment.status == 'paid':
        row['confirmed'] = 'active'
    else:
        row['confirmed'] = 'unsuccessful'
    row['is_editable'] = is_so and (row['confirmed'] == 'active')
    payments.append(row)

payments.sort(cmp=lambda x,y: cmp(x['trans_ref'],y['trans_ref']))
info['payments'] = payments
return info

